
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;
use work.my_package.all;
entity AB_cell is
port (
a, b, y: in STD_LOGIC_VECTOR (N downto 0);
cont_a: in std_logic_vector(2 downto 0);
first_step, last_step: in std_logic;
new_a, new_b: out STD_LOGIC_VECTOR (N downto 0)
);
end AB_cell;

architecture rtl of AB_cell is

signal op1, op2, sum: std_logic_vector(n downto 0);
signal sum_2: std_logic_vector(n-1 downto 0);

begin

  first_adder_operands: for i in 0 to n-1 generate
  op1(i) <= a(i+1);
  op2(i) <= cont_a(1) and(cont_a(0) xor b(i+1));
  end generate;
  op1(n) <= op1(n-1); op2(n) <= op2(n-1);

  sum <= op1 + op2 + cont_a(1);

  mux_1: for i in 0 to n-1 generate
    with cont_a(2) select sum_2(i) <= a(i+1) when '0', sum(i+1) when others;
  end generate;

  --with first_step select new_a(n-1 downto 0) <= sum_2 when '0', y(n-1 downto 0) when others;
  --with first_step select new_a(n) <= sum_2(n-1) when '0', y(n) when others;
  --with first_step select new_b <= a when '0', module(n downto 0) when others;

  new_a <= sum_2(n-1) & sum_2;
  new_b <= a;

end rtl;
