--------------------------------------------------------
--  
--------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;
use work.my_package.all;
library UNISIM;
use UNISIM.ALL;
use UNISIM.vcomponents.all;

entity adjust_z is
    port (
      v: in STD_LOGIC_VECTOR (N downto 0);
      B_neg, v_neg: in STD_LOGIC;
		  res: out STD_LOGIC_VECTOR (N-1 downto 0)
     );
end adjust_z;

architecture adj_arch of adjust_z is
signal i_res: STD_LOGIC_VECTOR (N downto 0);
signal sel: STD_LOGIC_VECTOR (1 downto 0);

begin

sumador_restador: process (B_neg, v_neg, sel, v)
begin	  
  sel <= B_neg & v_neg;
	case sel is
      when "00" => i_res <= v;
 			when "01" => i_res <= module(N downto 0) - v;
      when "10" => i_res <= module(N downto 0) + v;
      when "11" => i_res <= not(v) + 1; -- -v
      when others => i_res <= v;
   end case;

	res <= i_res(N-1 downto 0);
end process;

end adj_arch;


--architecture low_level of adjust_z is
--signal lut_out,carry_logic: std_logic_vector(N+2 downto 0);

--begin

--	carry_logic(0) <= '0';
--   iterac: for I in 0 to N-1 generate
--				the_xor: LUT3 generic map(init => init_lut_adj(i)) 
--								  port map (I0 => v(i), I1 => B_neg,I2 => v_neg, O => lut_out(i));
--				the_muxcy: MUXCY port map(DI => v(i) , CI =>carry_logic(i), S => lut_out(i), O => carry_logic(i+1));
--				the_xorcy: XORCY port map(CI =>carry_logic(i), LI =>lut_out(i), O => res(i) );
--		end generate;

-- end low_level; 
