--------------------------------------------------------
-- 
--------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;
use work.my_package.all;
library UNISIM;
use UNISIM.ALL;


entity s_r_n_cell is
    port (
        u: in STD_LOGIC_VECTOR (N downto 0);
        v: in STD_LOGIC_VECTOR (N downto 0);
        srn: in STD_LOGIC_VECTOR(1 downto 0);
		  res: out STD_LOGIC_VECTOR (N+1 downto 0)
     );
end s_r_n_cell;

architecture s_r_n_arch of s_r_n_cell is

begin

sumador_restador: process (srn,u,v)
begin
	case srn is
      when "00" => res <= u(N) & u;
			when "01" => res <= u(N) & u;
      when "10" => res <= (u(N) & u) + v;
      when "11" => res <= (u(N) & u) - v;
      when others => res <= (others => '1');
   end case;
end process;

end s_r_n_arch;


architecture low_level of s_r_n_cell is

component LUT4
  generic (INIT : bit_vector(15 downto 0));
  port (I0 : in std_logic;  I1 : in std_logic; I2 : in std_logic;  I3 : in std_logic;O : out std_logic );
end component;
 
component MUXCY
  port ( DI : in std_logic; CI : in std_logic;  S : in std_logic;   O : out std_logic );
end component;

component XORCY
 port ( CI : in std_logic; LI : in std_logic; O : out std_logic );
end component;

signal lut_out,carry_logic: std_logic_vector(N+2 downto 0);

begin

	carry_logic(0) <= srn(0);

	iterac: for I in 0 to N generate
				the_xor: LUT4 generic map(init => "1001011010101010") 
								  port map (I0 => u(I),I1 => v(I),I2 => srn(0),I3 => srn(1), O => lut_out(I));
				the_muxcy: MUXCY port map(DI => u(I) , CI =>carry_logic(I), S => lut_out(I), O => carry_logic(I+1));
				the_xorcy: XORCY port map(CI =>carry_logic(I), LI =>lut_out(I), O => res(I) );
		end generate;
		--Pasa N+1
		the_xor: LUT4 generic map(init => "1001011010101010") 
						  port map (I0 => u(N),I1 => v(N),I2 => srn(0),I3 => srn(1), O => lut_out(N+1));
		the_muxcy: MUXCY port map(DI => u(N) , CI =>carry_logic(N+1), S => lut_out(N+1), O => carry_logic(N+2));
		the_xorcy: XORCY port map(CI =>carry_logic(N+1), LI =>lut_out(N+1), O => res(N+1) );
 end low_level;